
// Clonen als Implementierung von Cloneable

import java.io.*;
/* Alternative zum Clonen:
class klasse {
  static int i = 0;
  int no;
  public klasse () { no = i++; }
  public klasse (klasse clone) { no = clone.no; }
  public void setno (int no) { this.no = no; }
  public void print () { System.out.println ("no " + no); }
}
*/

class klasse implements Cloneable {
  static int AnzahlElemente = 0;
  int no;
  public klasse () { no = AnzahlElemente++; }
  public klasse (klasse clone) { no = clone.no; }
  public Object clone() {
    try {
      klasse c = (klasse)super.clone();
      c.no = no;
      return c;
    }
    catch (CloneNotSupportedException e) {
      // eigentlich nicht zu erwarten
      throw new InternalError();
    }
  }
  public void setno (int no) { this.no = no; }
  public void print () { System.out.println ("no " + no); }
}

public class CloneDemo {
  public static void main (String args []) {
  klasse objekt1, objekt2;
  objekt1 = new klasse ();
  objekt2 = (klasse)(objekt1.clone ());
  klasse objekt3 = new klasse (objekt2);
  objekt1.print ();
  objekt2.print ();
  objekt3.print ();
  System.out.println (klasse.AnzahlElemente);
  }
}
