
// Ein uebliches Beispiel aus der OOP
// Klasse Obst
// Unterklassen Apfel Pfirsich Birne Orange usw...
// Elemente dieser Klasse werden in Container aufbewahrt und bearbeitet
//
// Klassenhierarchie
//
//Object
//+-------+ Obst
//        +------- Birne
//        +------- Pfirsich
//        \\------ Apfel


// Obst ist eine abstrakte Basisklasse, denn es gibt kein
// abstraktes Obst, es gibt nur konkret : Apfel, Birne usw...
abstract class Obst {
  protected int Gewicht; // Das Gewicht. Jedes Obst hat ein Gewicht.
  Obst (int Gewicht) { this.Gewicht = Gewicht; }
  abstract void wiege () ;     // Jedes Obst kann gewogen werden
  final void print () { System.out.print ("Gewicht " + Gewicht + " "); }
  abstract void printme ();
}

class Birne extends Obst {
  private String Name;
  Birne (String Name, int Gewicht) {
    super (Gewicht);
    this.Name = Name;
  }
  void wiege () { System.out.println ("Wiege die Birne " + Gewicht); }
  void printme () { System.out.println (Name); }
}

class Pfirsich extends Obst {
  private String Name;
  Pfirsich (String Name, int Gewicht) {
    super (Gewicht);
    this.Name = Name;
  }
  void wiege () { System.out.println ("Wiege den Pfirsich " + Gewicht); }
  void printme () { System.out.println (Name); }
}

class Apfel extends Obst {
  private String Name;
  Apfel (String Name, int Gewicht) {
    super (Gewicht);
    this.Name = Name;
  }
  void wiege () { System.out.println ("Wiege den Apfel " + Gewicht); }
  void printme () { System.out.println (Name); }
}

public class ObstHaendler {
  static public void main (String args[]) {
  System.out.println ("----------- start ------------");
  Birne    Helene   = new Birne    ("Helene", 2);
  Pfirsich Melba    = new Pfirsich ("Melba",  1);
  Apfel    NoName   = new Apfel    ("?",      3);

  // Die Fruechte werden in den Container gelegt
  Obst Fruchtkorb [] = new Obst [3];
  Fruchtkorb[0] = Helene;
  Fruchtkorb[1] = Melba;
  Fruchtkorb[2] = NoName;

  // Einfache Ausgabe des Containers
  for (int i = 0; i < Fruchtkorb.length; i++)
    Fruchtkorb[i].printme ();

  for (int i = 0; i < Fruchtkorb.length; i++)
    Fruchtkorb[i].wiege ();
  }
}
